﻿using System;
using System.ServiceModel;
using HelloWorldService;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;

namespace HelloWorldHost
{
	//
	// Hello World 서비스에 대한 WCF 호스트 구현
	//
	class HostApp
	{
		static void Main(string[] args)
		{
			//
			// 테스트 마다 다음 호스트 호출 중 하나를 사용하고 나머지는 주석으로
			// 막아야 한다.
			//

			//BasicHost();
			BasicHost2();
			//BasicHost3();
		}

		// 가장 단순한 호스트
		static void BasicHost()
		{
			// 다음 코드가 정상적으로 작동하기 위해서는 app.config 파일의
			// <services> 요소를 comment 로 막아 두어야 한다.
			ServiceHost host = new ServiceHost(typeof(HelloWorldWCFService),
				new Uri("http://localhost/wcf/example/helloworldservice"));

			host.AddServiceEndpoint(
				typeof(IHelloWorld),		// service contract
				new BasicHttpBinding(),		// service binding
				"");						// relative address

			host.Open();
			Console.WriteLine("Press Any key to stop the service");
			Console.ReadKey(true);
			host.Close();
		}

		// BasicHttpBinding과 NetTcpBinding을 사용하는 호스트
		static void BasicHost2()
		{
			// 다음 코드가 정상적으로 작동하기 위해서는 app.config 파일의
			// <services> 요소를 comment 로 막아 두어야 한다.
			ServiceHost host = new ServiceHost(typeof(HelloWorldWCFService),
				new Uri("http://localhost/wcf/example/helloworldservice"),
				new Uri("net.tcp://localhost/wcf/example/helloworldservice"));

			host.AddServiceEndpoint(
				typeof(IHelloWorld),		// service contract
				new BasicHttpBinding(),		// service binding
				"");						// relative address
			host.AddServiceEndpoint(
				typeof(IHelloWorld),		// service contract
				new NetTcpBinding(),		// service binding
				"");						// relative address

			host.Open();
			Console.WriteLine("Press Any key to stop the service");
			Console.ReadKey();
			host.Close();
		}

		// 베이스 주소를 사용하지 않고 BasicHttpBinding에 대한 설정하는 호스트
		static void BasicHost3()
		{
			// 다음 코드가 정상적으로 작동하기 위해서는 app.config 파일의
			// <services> 요소를 comment 로 막아 두어야 한다.
			ServiceHost host = new ServiceHost(typeof(HelloWorldWCFService));
			BasicHttpBinding binding = new BasicHttpBinding();
			host.AddServiceEndpoint(
				typeof(IHelloWorld),        // service contract
				binding,					// service binding
				"http://localhost/wcf/example/helloworldservice");

			host.AddServiceEndpoint(
				typeof(IHelloWorld),        // service contract
				new NetTcpBinding(),        // service binding
				"net.tcp://localhost/wcf/example/helloworldservice");

			host.Open();
			Console.WriteLine("Press Any key to stop the service");
			Console.ReadKey();
			host.Close();
		}
	}
}
