﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Channels;

namespace ReliableServiceApp
{
	[ServiceContract]
	interface IReliableMessaging
	{
		[OperationContract]
		void ReliableMethod(string arg);
	}

	class ReliableMessagingService : IReliableMessaging
	{
		public void ReliableMethod(string arg)
		{
			Console.WriteLine("Reliable Method Invoked... arg={0}", arg);
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Reliable Messaging Test Service ......");

			WSHttpBinding binding = new WSHttpBinding();
			binding.Security.Mode = SecurityMode.None;
			binding.ReliableSession.Enabled = true;

			// 커스텀 바인딩 예제 코드
			// 위의 WSHttpBinding과 완전히 동등한 바인딩이다.
			//CustomBinding binding = new CustomBinding();
			//HttpTransportBindingElement transportElement = new HttpTransportBindingElement();
			//TextMessageEncodingBindingElement encodingElement = new TextMessageEncodingBindingElement();
			//ReliableSessionBindingElement reliableElement = new ReliableSessionBindingElement();
			//binding.Elements.Add(reliableElement);
			//binding.Elements.Add(encodingElement);
			//binding.Elements.Add(transportElement);

			ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			behavior.HttpGetEnabled = true;

			ServiceHost host = new ServiceHost(typeof(ReliableMessagingService),
				new Uri("http://localhost/wcf/example/rm/basic"));
			host.AddServiceEndpoint(typeof(IReliableMessaging), binding, "");
			host.Description.Behaviors.Add(behavior);

			host.Open();
			Console.WriteLine("Service started. Press any key to stop......");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
