﻿using System;
using System.Security.Cryptography.X509Certificates;
using SecureClientApp.SecureService;
using System.ServiceModel;
using System.ServiceModel.Security;

namespace SecureClientApp
{
	class SecureClient
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Message Security - Certificate Authentication Test Client......");

			X509Certificate2 serviceCert = new X509Certificate2("..\\..\\..\\..\\Certs\\localhost.cer");
			X509Certificate2 clientCert1 = new X509Certificate2("..\\..\\..\\..\\Certs\\TestUser.pfx", "1234");
			X509Certificate2 clientCert2 = new X509Certificate2("..\\..\\..\\..\\Certs\\TestUser2.pfx", "1234");

			Console.WriteLine("Calling the service with TestUser certificate...");
			using (SecureServiceClient proxy = new SecureServiceClient()) {
				proxy.ClientCredentials.ClientCertificate.Certificate = clientCert1;
				proxy.ClientCredentials.ServiceCertificate.DefaultCertificate = serviceCert;
				try {
					proxy.SecureMethod("Hello a certificate world !");
					proxy.SecureMethod("Another Hello Message...");
				}
				catch (MessageSecurityException ex) {
					Console.WriteLine("  Error: {0}", ex.InnerException.Message);
					proxy.Abort();
				}
			}


			Console.WriteLine("Calling the service with TestUser2 certificate...");
			using (SecureServiceClient proxy = new SecureServiceClient()) {
				proxy.ClientCredentials.ClientCertificate.Certificate = clientCert2;
				proxy.ClientCredentials.ServiceCertificate.DefaultCertificate = serviceCert;
				try {
					proxy.SecureMethod("Hello a certificate world !");
				}
				catch (MessageSecurityException ex) {
					Console.WriteLine("  Error: {0}", ex.InnerException.Message);
					proxy.Abort();
				}
			}
		}
	}
}
