﻿using System;
using System.Collections.Generic;
using System.Text;
using SecureClientApp.SecureService;
using System.Net;
using System.Security.Principal;

namespace SecureClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Client Impersonation Test Service......");

			using (SecureServiceClient proxy = new SecureServiceClient()) {
				proxy.ClientCredentials.Windows.AllowedImpersonationLevel = TokenImpersonationLevel.Identification;
				proxy.SecureMethod("call with a base windows identity");
				proxy.SecureMethod2("call with a base windows identity");
				Console.WriteLine("Invoking the service with a base windows identity");
			}

			using (SecureServiceClient proxy = new SecureServiceClient()) {
				proxy.ClientCredentials.Windows.ClientCredential =
					new NetworkCredential("Tester", "1234");
				proxy.SecureMethod("call with a specific windows identity");
				proxy.SecureMethod2("call with a specific windows identity");
				Console.WriteLine("Invoking the service with a specific windows identity");
			}
		}
	}
}
