﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Security.Principal;

namespace SecureServiceApp
{
	[ServiceContract]
	interface ISecureService
	{
		[OperationContract]
		void SecureMethod(string arg);
	}

	class SecureService : ISecureService
	{
		public void SecureMethod(string arg)
		{
			Console.WriteLine("SecureMethod invoked... arg={0}", arg);
			Console.WriteLine("  User = {0}", ServiceSecurityContext.Current.PrimaryIdentity.Name);
			WindowsIdentity identity = WindowsIdentity.GetCurrent();
			Console.WriteLine("  Windows Account = {0}", identity.Name);
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Windows Authentication Test Service......");

			WSHttpBinding binding = new WSHttpBinding();
			binding.Security.Mode = SecurityMode.Message;
			binding.Security.Message.ClientCredentialType = MessageCredentialType.Windows;

			ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			behavior.HttpGetEnabled = true;

			ServiceHost host = new ServiceHost(typeof(SecureService),
				new Uri("http://localhost/wcf/example/security/windowsauth"));
			host.AddServiceEndpoint(typeof(ISecureService), binding, "");
			host.Description.Behaviors.Add(behavior);

			host.Open();
			Console.WriteLine("The service started... Press any key to stop...");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
