﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Runtime.Serialization;
using UserInfoExtension;

namespace TestServiceApp
{
	[ServiceContract]
	interface ITestService
	{
		[OperationContract]
		void DoServerWork(string arg);
	}

	[ServiceBehavior(IncludeExceptionDetailInFaults = true)]
	class TestService : ITestService
	{
		public void DoServerWork(string arg)
		{
			Console.WriteLine("DoServerWork() invoked.....");
			if (UserInfo.Current != null) {
				UserInfo user = UserInfo.Current;
				Console.WriteLine("  User Info: id={0}  name={1}  dept={2}",
					user.UserId, user.Name, user.DeptId);
			}
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Message Inspector Test Service......");

			ServiceHost host = new ServiceHost(typeof(TestService));

			//foreach (ServiceEndpoint ep in host.Description.Endpoints) {
			//    ep.Behaviors.Add(new UserInfoBehavior());
			//}

			host.Open();
			Console.WriteLine("The service started... Press any key to stop...");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
