﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace HelloWorldClient
{
	// 서비스 Contract 선언
	[ServiceContract(Namespace = "http://www.simpleisbest.net/wcf/helloworld")]
	public interface IHelloWorld
	{
		[OperationContract]
		string SayHello();
	}

	//
	// Hello World 서비스 클라이언트 구현
	// (서비스 어셈블리를 참조하지 않는 버전
	//
	class Program
	{
		static void Main(string[] args)
		{
			Uri uri =
				   new Uri("http://localhost/wcf/example/helloworldservice");
			ServiceEndpoint ep = new ServiceEndpoint(
				ContractDescription.GetContract(typeof(IHelloWorld)),
				new BasicHttpBinding(),
				new EndpointAddress(uri));
			((BasicHttpBinding)ep.Binding).MessageEncoding = WSMessageEncoding.Mtom;

			ChannelFactory<IHelloWorld> factory =
												  new ChannelFactory<IHelloWorld>(ep);
			IHelloWorld proxy = factory.CreateChannel();
			string result = proxy.SayHello();
			(proxy as IDisposable).Dispose();

			Console.WriteLine(result);
		}
	}
}
