﻿using System;
using System.Messaging;

namespace MsmqService
{
	class Program
	{
		static void Main(string[] args)
		{
			string path = ".\\private$\\HelloWorldQueue";
			MessageQueue queue = new MessageQueue(path);
			queue.Formatter = new BinaryMessageFormatter();

			// 큐 존재 여부 파악후 생성
			if (MessageQueue.Exists(path) == false) {
				MessageQueue.Create(path);
			}

			Console.WriteLine("Hello World MSMQ Service Application");

			// 이벤트 기반 비동기 메시지 수신
			queue.ReceiveCompleted += new ReceiveCompletedEventHandler(OnReceiveCompleted);
			queue.BeginReceive();

			Console.WriteLine("Press Any Key to Stop...");
			Console.ReadKey(true);
			queue.Close();
		}

		// 비동기 메시지 수신 이벤트 핸들러
		static void OnReceiveCompleted(object sender, ReceiveCompletedEventArgs e)
		{
			MessageQueue queue = (MessageQueue)sender;
			Console.WriteLine("OnReceiveCompleted...");
			try {
				// 수신 완료
				Message msg = queue.EndReceive(e.AsyncResult);
				// 결과 출력
				Console.WriteLine("Message received : {0}", msg.Body.ToString());
				// 다음 메시지 수신을 위해 호출해야 한다.
				queue.BeginReceive();
			}
			catch (Exception ex) {
				Console.WriteLine(ex.ToString());
			}
		}
	}
}
