﻿using System;
using System.Runtime.Remoting;
using System.Diagnostics;

namespace RemotingClient
{
	class Program
	{
		static void Main(string[] args)
		{
			string result;
			Console.WriteLine(".NET Remoting Test Client...");

			// 전형적인 리모팅 프로그래밍 모델.
			// 원격으로 사용할 타입을 리모팅 런타임에 등록하고
			// 원격 타입에 대한 객체를 생성하면 원격 객체에 대한 프록시가 생성된다.
			// 클라이언트는 하나의 채널만 사용할 수 있다.
			//RemotingConfiguration.RegisterWellKnownClientType(		// TCP 채널
			//    typeof(RemotingService.HelloWorldService),
			//    "tcp://localhost:8080/HelloWorldService.rem");
			//RemotingConfiguration.RegisterWellKnownClientType(		// HTTP 채널
			//    typeof(RemotingService.HelloWorldService),
			//    "http://localhost:8088/HelloWorldService.rem");
			RemotingConfiguration.RegisterWellKnownClientType(		// IPC 채널
				typeof(RemotingService.HelloWorldService),
				"ipc://localhost:8089/HelloWorldService.rem");
			RemotingService.HelloWorldService obj = new RemotingService.HelloWorldService();
			Debug.Assert(RemotingServices.IsTransparentProxy(obj) == true);
			result = obj.SayHello();
			Console.WriteLine("Result : {0}", result);

			// 인터페이스를 사용하고자 하는 경우 new를 사용할 수 없고
			// Activator.GetObject 메쏘드를 호출하여 원격 객체에 대한 프록시 생성 후
			// 그에 대한 인터페이스를 사용한다.
			RemotingService.IHelloWorld remoteObject =
				(RemotingService.IHelloWorld)Activator.GetObject(typeof(RemotingService.IHelloWorld),
				"tcp://localhost:8080/HelloWorldService2.rem");
			result = remoteObject.SayHello();
			Console.WriteLine("Result #2 : {0}", result);
		}
	}
}
