﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace ClassContractService
{
	[ServiceContract(Namespace="http://noname.com/bookstore")]
	class BookStore
	{
		private static int id = 0;

		// 도서의 단가를 반환한다.
		private int GetUnitPrice(string isbn)
		{
			// 고정값... -_-;
			return 35000;
		}

		// 도서 주문
		[OperationContract]
		protected int Order(string userid, string isbn, int amount)
		{
			int total = GetUnitPrice(isbn) * amount;
			id += 1;
			// 주문 처리 로직
			// (단순 출력만... -_-; )
			Console.WriteLine(
				"Book Order: orderid={0}\n   userid={1}, isbn={2}, amount={3}, total={4}",
				id, userid, isbn, amount, total);
			// 주문 ID 반환
			return id;
		}

		// 주문 취소
		[OperationContract]
		public bool Cancel(int orderid)
		{
			// 주문 취소 로직
			// (단순 출력만... ^^;
			Console.WriteLine("Cancel Order: orderid={0}", orderid);
			return true;
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Class Contract Service Example...");

			ServiceHost host = new ServiceHost(
				typeof(BookStore),
				new Uri("http://localhost/wcf/example/bookstoreservice"));

			// 종점 추가
			host.AddServiceEndpoint(
				typeof(BookStore),
				new BasicHttpBinding(),
				"");

			// WSDL 을 위한 HTTP GET enable
			ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			behavior.HttpGetEnabled = true;
			host.Description.Behaviors.Add(behavior);

			host.Open();
			Console.WriteLine("Press Any Key to Stop Service...");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
