﻿using System;

using DataContractInheritanceClient.Graphics;

namespace DataContractInheritanceClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Data Contract Inheritance Client Example");

			Geometry g = new Rectangle();
			g.Id = 101;
			g.Left = g.Top = 1;
			g.Width = g.Height = 111;

			using (GraphicsClient proxy = new GraphicsClient()) {
				proxy.AddGeometry(g);
				g = proxy.GetGeometry(0);
				Console.WriteLine("Geometry Object = {0}", g.GetType().Name);
				Console.WriteLine("   ({0},{1}) - ({2}, {3})",
					g.Left, g.Top, g.Left + g.Width, g.Top + g.Height);
				g = proxy.GetGeometry(1);
				Console.WriteLine("Geometry Object = {0}", g.GetType().Name);
				Console.WriteLine("   ({0},{1}) - ({2}, {3})",
					g.Left, g.Top, g.Left + g.Width, g.Top + g.Height);
				g = proxy.GetGeometry(2);
				Console.WriteLine("Geometry Object = {0}", g.GetType().Name);
				Console.WriteLine("   ({0},{1}) - ({2}, {3})",
					g.Left, g.Top, g.Left + g.Width, g.Top + g.Height);
				g = proxy.GetGeometry(3);
				Console.WriteLine("Geometry Object = {0}", g.GetType().Name);
				Console.WriteLine("   ({0},{1}) - ({2}, {3})",
					g.Left, g.Top, g.Left + g.Width, g.Top + g.Height);
			}
		}
	}
}
