﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;

using ServiceImplementation;

namespace NetDataContractSerializerClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Using NetDataContractSerializer Client Example...");

			int orderid;

			ServiceEndpoint ep = new ServiceEndpoint(
				ContractDescription.GetContract(typeof(IBookStore)));
			BasicHttpBinding binding = new BasicHttpBinding();
			string remoteAddress = "http://loner/wcf/example/bookstoreservice";

			ChannelFactory<IBookStore> factory = new ChannelFactory<IBookStore>(binding, remoteAddress);
			IBookStore proxy = factory.CreateChannel();

			using (proxy as IDisposable) {
				orderid = proxy.Order("GoPl", "999-9-999-99999-9", 2);
				Console.WriteLine("Place Order. Order ID = {0}", orderid);

				BookInfo info = proxy.GetBookInfo("000-005");
				Console.WriteLine("Book Information:\n  Title={0}\n  Author={1}\n  ISBN={2}\n  Price={3:#,##0} Won",
					info.Title, info.Author, info.Isbn, info.Price);
			}
		}
	}
}
