﻿using System;
using System.Collections.Generic;
using System.Text;

using SimpleCustomBindingClient.BookStore;
using System.ServiceModel;

namespace SimpleCustomBindingClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("BookStore Client Application");

			int orderid;

			// 비록 서비스가 CustomBinding을 사용하고 있지만 WSDL에는 CustomBinding 이라는
			// 정보가 포함되어 잇지 않다. Svcutil.exe는 철저히 WSDL 만을 참조하므로 WSDL이
			// 제공하는 정보로는 BasicHttpBinding과 완전히 동일한 바인딩이기 때문에
			// 프록시 코드는 BasicHttpBinding이 사용된다.
			using (BookStoreClient proxy = new BookStoreClient()) {
				orderid = proxy.Order("Tester", "999-9-999-99999-9", 2);
				Console.WriteLine("Place Order. Order ID = {0}", orderid);
			}
		}
	}
}
