﻿using System;
using System.ServiceModel;

namespace TestClientApp
{
	[ServiceContract]
	interface ITestContract1
	{
		[OperationContract]
		void Method1();
	}

	[ServiceContract]
	interface ITestContract2
	{
		[OperationContract]
		void Method2();
	}

	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Named Pipe URI Test Client......");

			string address1 = "net.pipe://localhost/samples/testservice1";
			string address2 = "net.pipe://localhost/samples/testservice2";

			ITestContract1 proxy1 = CreateProxy<ITestContract1>(address1);
			ITestContract2 proxy2 = CreateProxy<ITestContract2>(address2);

			proxy1.Method1();
			proxy2.Method2();

			(proxy1 as IDisposable).Dispose();
			(proxy2 as IDisposable).Dispose();
		}

		// 주어진 계약 인터페이스와 주소를 이용하여 프록시를 생성한다.
		static TContracType CreateProxy<TContracType>(string address)
		{
			NetNamedPipeBinding binding = new NetNamedPipeBinding();
			EndpointAddress remoteAddress = new EndpointAddress(address);
			ChannelFactory<TContracType> factory = new ChannelFactory<TContracType>(binding, remoteAddress);
			TContracType proxy = factory.CreateChannel();
			return proxy;
		}
	}
}
