﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace TestServiceApp2
{
	class ServiceApp2
	{
		[ServiceContract]
		interface ITestContract2
		{
			[OperationContract]
			string TestMethod();
		}

		class TestService2 : ITestContract2
		{
			public string TestMethod()
			{
				return "TestService2.TestMethod";
			}
		}

		static void Main(string[] args)
		{
			Console.WriteLine("TCP Port Sharing Sample Service #2 ......");

			// HTTP를 통해 WSDL을 제공하기 위해 HTTP 베이스 주소를 제공했다.
			// 실제 서비스 종점은 net.tcp 에 대해서만 제공한다.
			ServiceHost host = new ServiceHost(typeof(TestService2),
				new Uri("http://localhost/wcf/example/testservice2"),
				new Uri("net.tcp://localhost:8000/testservice1"));

			// 바인딩 설정 및 서비스 종점 추가
			NetTcpBinding binding = new NetTcpBinding();
			binding.PortSharingEnabled = true;
			host.AddServiceEndpoint(typeof(ITestContract2), binding, 
				"net.tcp://localhost:8000/testservice2");

			// WSDL에 대한 HTTP GET을 enable
			ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			behavior.HttpGetEnabled = true;
			host.Description.Behaviors.Add(behavior);

			// 서비스 리스너 구동 및 서비스 수행
			host.Open();
			Console.WriteLine("Press Any Key to Stop Service......");
			Console.ReadKey(true);

			// 서비스 종료
			host.Close();
		}
	}
}
