﻿using System;
using System.ServiceModel;


namespace MultipleServiceApp
{
	[ServiceContract]
	interface IContract1
	{
		[OperationContract]
		void Method1();
	}

	[ServiceContract]
	interface IContract2
	{
		[OperationContract]
		void Method2();
	}

	[ServiceContract]
	interface IContract3
	{
		[OperationContract]
		void Method3();
	}

	class Service1 : IContract1
	{
		public void Method1()
		{
			Console.WriteLine("Method1");
		}
	}

	class Service2 : IContract2
	{
		public void Method2()
		{
			Console.WriteLine("Method2");
		}
	}

	class Service3 : IContract3
	{
		public void Method3()
		{
			Console.WriteLine("Method3");
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Multiple Service Example......");

			ServiceHost host1 = new ServiceHost(typeof(Service1),
				new Uri("http://localhost/wcf/example/service1"),
				new Uri("net.tcp://localhost/wcf/example/service1"));
			ServiceHost host2 = new ServiceHost(typeof(Service2),
				new Uri("http://localhost/wcf/example/service2"),
				new Uri("net.tcp://localhost/wcf/example/service2"));
			ServiceHost host3 = new ServiceHost(typeof(Service3),
				new Uri("http://localhost/wcf/example/service3"),
				new Uri("net.tcp://localhost/wcf/example/service3"));

			host1.Open();
			host2.Open();
			host3.Open();

			Console.WriteLine("Press any key to stop the services");
			Console.ReadKey(true);

			host1.Close();
			host2.Close();
			host3.Close();
		}
	}
}
