﻿using System;
using TestClientApp.BookStore;
using TestClientApp.InlineService;
using TestClientApp.TestService;

namespace TestClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("IIS Hosting Test Client Sample......");

			using (InlineServiceClient proxy = new InlineServiceClient()) {
				string result = proxy.Echo("IIS Hosting World !");
				Console.WriteLine("Inline Service Result: {0}", result);
			}

			using (BookStoreClient proxy = new BookStoreClient()) {
				BookInfo[] infos = proxy.GetBookList();
				foreach (BookInfo info in infos) {
					Console.WriteLine("{0}, {1}, {2}", info.Isbn, info.Title, info.Author);
				}
			}

			using (TestServiceClient proxy = new TestServiceClient()) {
				string result1 = proxy.TestMethod();
				Console.WriteLine("Test Service Result1: {0}", result1);

				string result2 = proxy.TestMethod();
				Console.WriteLine("Test Service Result2: {0}", result2);
			}
		}
	}
}
