﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WinFormClient.BookStoreService;

namespace WinFormClient
{
	public partial class ClientForm : Form
	{
		public ClientForm()
		{
			InitializeComponent();
		}

		private void btnGetList_Click(object sender, EventArgs e)
		{
			using (BookStoreClient proxy = new BookStoreClient()) {
				BindingList<BookInfo> books = proxy.GetBookList();
				dgvBooks.AutoGenerateColumns = false;
				dgvBooks.DataSource = books;
			}
		}

		private void btnOrder_Click(object sender, EventArgs e)
		{
			BookInfo info;
			string userid = txtUserId.Text;
			int amount = 0;

			if (Int32.TryParse(txtAmount.Text, out amount) == false) {
				MessageBox.Show("Invalid book amount.", "Book Order Error",
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				txtAmount.Focus();
				return;
			}
			if (dgvBooks.SelectedRows.Count > 0) {
				info = (BookInfo)dgvBooks.SelectedRows[0].DataBoundItem;
			}
			else {
				MessageBox.Show("Select the book before order", "Book Order Error",
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			using (BookStoreClient proxy = new BookStoreClient()) {
				int orderId = proxy.Order(userid, info.Isbn, amount);
				MessageBox.Show("Your order is placed. Remember the Order Id, " + orderId.ToString(),
					"Book Order Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}
	}
}