﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace ExceptionServiceApp
{
	[ServiceContract]
	interface IBadContract
	{
		[OperationContract]
		void ThrowException();
		[OperationContract]
		void ThrowInvalidOperationException();
		[OperationContract]
		void ThrowNullReferenceException();
	}

	//[ServiceBehavior(IncludeExceptionDetailInFaults = true)]
	class BadService : IBadContract
	{
		public void ThrowException()
		{
			Console.WriteLine("Throwing Exception");
			throw new Exception("Test Exception");
		}

		public void ThrowInvalidOperationException()
		{
			Console.WriteLine("Throwing InvalidOperationException");
			throw new InvalidOperationException("Test InvalidOperationException");
		}

		public void ThrowNullReferenceException()
		{
			Console.WriteLine("Throwing NullReferenceException");
			DoThrow();
		}

		private void DoThrow()
		{
			object obj = null;
			// null reference exception 발생
			obj.GetType();
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("WCF Basic Exception Handling Example......");

			// 베이스 주소 및 종점 설정은 configuration 파일을 사용한다.
			ServiceHost host = new ServiceHost(typeof(BadService));

			// 디버깅 옵션 설정
			//ServiceDebugBehavior behavior = 
			//    host.Description.Behaviors.Find<ServiceDebugBehavior>();
			//if (behavior == null) {
			//    behavior = new ServiceDebugBehavior();
			//    host.Description.Behaviors.Add(behavior);
			//}
			//behavior.IncludeExceptionDetailInFaults = true;

			host.Open();
			Console.WriteLine("Press any key to stop the service");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
