﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using TestServiceB.SvcA;

namespace TestServiceB
{
	[ServiceContract]
	interface IServiceB
	{
		[OperationContract]
		void OutgoingCall();
	}

	[ServiceBehavior(IncludeExceptionDetailInFaults = true)]
	class ServiceB : IServiceB
	{
		// 클라이언트(ServiceA)가 호출하는 메쏘드
		public void OutgoingCall()
		{
			Console.WriteLine("ServiceB : call from ServiceA...");
			// 서비스 A를 다시 호출한다.
			using (ServiceAClient proxy = new ServiceAClient()) {
				proxy.ReentrantCall();
			}
			Console.WriteLine("ServiceB : successful call to ServiceB");
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Reentrant Concurrency Mode Test : ServiceB ......");
			ServiceHost host = new ServiceHost(typeof(ServiceB),
				new Uri("http://localhost/wcf/example/concurrencymode/reentrant/serviceB"));
			host.Open();
			Console.WriteLine("ServiceB started......");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
