﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.ServiceModel;

namespace TestServiceApp
{
	[ServiceContract]
	interface IPerCallService
	{
		[OperationContract]
		void TestMethod(int delay);
	}

	[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
	class PerCallService : IPerCallService, IDisposable
	{
		private static int _ObjectCount = 0;

		public PerCallService()
		{
			Interlocked.Increment(ref _ObjectCount);
			Console.WriteLine("++ PerCallService object created, count={0}", _ObjectCount);
		}

		public void Dispose()
		{
			Interlocked.Decrement(ref _ObjectCount);
			Console.WriteLine("-- PerCallService object released, count={0}", _ObjectCount);
		}

		public void TestMethod(int delay)
		{
			Thread.Sleep(delay);
		}
	}

}
