﻿using System;
using System.Collections.Generic;
using System.Text;
using CallbackTestClient.TestService;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace CallbackTestClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Simple Callback Test Client Sample......");

			Console.WriteLine("Call the service using WSDualHttpBinding......");
			InstanceContext ctx = new InstanceContext(new CallbackHandler());
			using (TestContractClient proxy = new TestContractClient(ctx, "WSDualHttpBinding_ITestContract")) {
				WSDualHttpBinding wsDualHttpBinding = (WSDualHttpBinding)proxy.Endpoint.Binding;
				Console.WriteLine("Client call base address = {0}", wsDualHttpBinding.ClientBaseAddress);
				wsDualHttpBinding.ClientBaseAddress = new Uri("http://localhost/wcf/example/callback/client");

				Console.WriteLine("Before call TestMethod...");
				proxy.TestMethod();
				Console.WriteLine("After call TestMethod...");
			}

			Console.WriteLine("Call the service using NetTcpBinding......");
			InstanceContext ctx2 = new InstanceContext(new CallbackHandler());
			using (TestContractClient proxy = new TestContractClient(ctx2, "NetTcpBinding_ITestContract")) {
				Console.WriteLine("Before call TestMethod...");
				proxy.TestMethod();
				Console.WriteLine("After call TestMethod...");
			}
		}

	}

	class CallbackHandler : ITestContractCallback
	{
		public void OnCallback(string message)
		{
			Console.WriteLine("Callback: {0}", message);
		}
	}
}
