﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Diagnostics;
using TestClientApp.LogService;

namespace TestClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("One-way Call Test Client Sample......");

			//DoTest("BasicHttpBinding_ILog");
			//DoTest("WSHttpBinding_ILog");
			//DoTest("NetTcpBinding_ILog");

			//DoTest2("BasicHttpBinding_ILog");
			//DoTest2("WSHttpBinding_ILog");
			DoTest2("NetTcpBinding_ILog");

		}

		static void DoTest(string bindingConfigName)
		{
			Stopwatch sw = new Stopwatch();
			sw.Start();
			using (LogClient proxy = new LogClient(bindingConfigName)) {
				string msg = String.Format("message from {0} test client...", bindingConfigName);
				for (int i = 0; i < 5; i++) {
					proxy.LogMessage(msg);
					Console.WriteLine("Oneway call #{0}", i+1);
				}
			}
			sw.Stop();
			Console.WriteLine("Elapsed time : {0:#,##0} msec", sw.ElapsedMilliseconds);
		}

		static void DoTest2(string bindingConfigName)
		{
			string msg = String.Format("message from {0} test client...", bindingConfigName);
			using (LogClient proxy = new LogClient(bindingConfigName)) {
				Console.WriteLine("Oneway call with Error...");
				proxy.LogMessageWithError();
				Console.WriteLine("Oneway call again...");
				proxy.LogMessage(msg);
				Console.WriteLine("Oneway call again...");
				proxy.LogMessage(msg);
				Console.WriteLine("Disposing Proxy...");
			}
		}
	}
}
